<app-loading *ngIf="isLoading"></app-loading>
<div nz-row [nzGutter]='[30,0]' class='btn-fixed-right'>
  <div nz-col [nzXs]='24' [nzLg]='24' [ngStyle]="{'text-align': 'right'}" *ngIf='objFunction?.edit'>
    <mb-button
      mbButtonSize='SMALL'
      mbButtonAvailableStyle='PRIMARY'
      (click)='onAddParam()'
      mbButtonText="{{'common.button.add' | translate}}"
    ></mb-button>
    <mb-button
      mbButtonSize='SMALL'
      mbButtonAvailableStyle='PRIMARY'
      (click)='onSave()'
      mbButtonText="{{'common.button.save' | translate}}"
    ></mb-button>

  </div>
</div>
<div class='app-list'>
  <form [formGroup]='form'>
  <div nz-row [nzGutter]='[30,30]' class='data-table'>
    <ng-container formArrayName='listThanksConfig'>
      <nz-table nz-col nzXs='24' nzLg='24' [nzData]='form.controls["listThanksConfig"].value' nzSize='small' [nzScroll]="{ y: '70vh' }"
                [nzShowPagination]='false' [nzPageSize]='form.controls["listThanksConfig"].value.length' nzTableLayout='fixed'>
        <thead>
        <tr class='table-header'>
          <th nzWidth='5%' class='config-center'>STT</th>
          <th nzWidth='50%'>{{'angleIt.config.thankYou' | translate}}</th>
          <th nzWidth='20%'>{{'angleIt.config.image' | translate}}</th>
          <th nzWidth='18%'>{{'angleIt.config.effect' | translate}}</th>
          <th nzWidth='7%' *ngIf='objFunction?.edit || objFunction?.delete'></th>
        </tr>
        </thead>
        <tbody>
        <tr *ngFor='let data of listThanksConfig?.controls; let i = index; let first = first' [formGroupName]='i'>
          <td [ngStyle]='{"max-width": "5%"}' class='config-center'>
            {{ i + 1 }}
          </td>
          <td [ngStyle]='{"max-width": "50%"}'>
            <mb-input-text *ngIf='data.controls["isEdit"].value; else thanhYou'
              formControlName='content' [mbMaxLength]="200"
              [mbType]="isSubmitted && data.controls['content']?.errors ? 'error' : 'default'"
              [mbShowError]="isSubmitted && data.controls['content']?.errors != null"
              [mbErrors]="data.controls['content']?.errors"
              [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'angleIt.validate.required' | translate: {'param': 'angleIt.config.thankYou' | translate }}]"
              mbPlaceholderText="{{'angleIt.config.thankYou' | translate}}">
            </mb-input-text>
            <ng-template #thanhYou>
              <div class='ellipsis' nzTooltipTitle="{{data.controls['content'].value.length > 50 ? data.controls['content'].value : ''}}"
                    nzTooltipPlacement="bottom" nz-tooltip> {{data.controls['content'].value}}</div>
            </ng-template>
            <div *ngIf="isError && checkError(i,data,'contentError')" class=error-message>
              <em nz-icon nzType="close-circle" nzTheme="outline"></em>
              <span class="text__message">{{checkError(i,data,'contentError')}}</span>
            </div>
          </td>
          <td [ngStyle]='{"max-width": "20%"}'>
            <div class='table-image'>
              <nz-avatar [nzShape]="'square'" [nzSize]="96" nzIcon="picture" nzSrc="{{data.controls['imageData'].value}}"></nz-avatar>
              <div class='choose-image' *ngIf='data.controls["isEdit"].value' (click)='selectImage(data)'>
                <label class='select-image'>{{'angleIt.config.clickSelectImage' | translate}}</label>
              </div>
            </div>
            <div *ngIf="isSubmitted && !data.controls['imageId'].value && !data.controls['image'].value" class=error-message>
              <em nz-icon nzType="close-circle" nzTheme="outline"></em>
              <span class="text__message">{{'angleIt.validate.required' | translate: { 'param': 'angleIt.config.image' | translate } }}</span>
            </div>
            <div *ngIf="isError && checkError(i,data,'imageError')" class=error-message>
              <em nz-icon nzType="close-circle" nzTheme="outline"></em>
              <span class="text__message">{{checkError(i,data,'imageError')}}</span>
            </div>
          </td>
          <td [ngStyle]='{"max-width": "18%"}'>
            <mb-select *ngIf='data.controls["isEdit"].value; else effect'
              [mbDataSelects]='listStatus'
              mbKeyLabel='label'
              mbKeyValue='value'
              [mbType]="isSubmitted && data.controls['flagStatus']?.errors ? 'error' : 'default'"
              [mbShowError]="isSubmitted && data.controls['flagStatus']?.errors != null"
              [mbErrors]="data.controls['flagStatus']?.errors"
              [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'angleIt.validate.required' | translate: {'param': 'angleIt.config.effect' | translate }}]"
              mbPlaceholder="{{'angleIt.config.effect' | translate}}"
              formControlName='flagStatus'></mb-select>
            <ng-template #effect>
              <ng-container *ngFor='let item of constant.CONFIG_STATUS'>
                <nz-tag [nzColor]="item.bgColor" [ngStyle]="{'color': item.color}" *ngIf='data.controls["flagStatus"].value === item.value'>{{item.label | translate}}</nz-tag>
              </ng-container>
            </ng-template>
            <div *ngIf="isError && checkError(i, data, 'flagStatusError')" class=error-message>
              <em nz-icon nzType="close-circle" nzTheme="outline"></em>
              <span class="text__message">{{checkError(i, data, 'flagStatusError')}}</span>
            </div>
          </td>
          <td class='config-center' [ngStyle]='{"max-width": "7%"}' *ngIf='objFunction?.edit || objFunction?.delete'>
            <mb-button-icon *ngIf="data.controls['thankyouSettingId'].value && data.controls['isEdit'].value" mbButtonType="RESET" (click)="reset(data)"> </mb-button-icon>
            <mb-button-icon *ngIf="objFunction?.edit && data.controls['thankyouSettingId'].value && !data.controls['isEdit'].value" mbButtonType="EDIT" (click)="edit(data)"> </mb-button-icon>
            <mb-button-icon *ngIf="(objFunction?.delete && data.controls['thankyouSettingId'].value) || !data.controls['thankyouSettingId'].value" mbButtonType="DELETE" (click)="delete(data, i)"> </mb-button-icon>
          </td>
        </tr>
        </tbody>
      </nz-table>
    </ng-container>
  </div>
  </form>
</div>


<ng-template #modalFooterTmpl>
  <mb-button mbButtonType="BORDER"  mbButtonSize="LARGE" (click)="modalRef?.getContentComponent().close()" mbButtonBgColor="transparent"
             mbButtonAvailableStyle="DEFAULT" mbButtonText="{{'common.button.cancel' | translate}}"></mb-button>
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modalRef?.getContentComponent().choose()"
             mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.select' | translate}}"></mb-button>
</ng-template>
